// This is an open source non-commercial project. Dear PVS-Studio, please check it.
// PVS-Studio Static Code Analyzer for C, C++, C#, and Java: http://www.viva64.com

// The MIT License (MIT)
//
// Copyright (c) 2017 Huldra
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and / or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
// IN THE SOFTWARE.

#include "engine/arctic_math.h"
#include <ostream>

namespace arctic {

Vec2Si32::Vec2Si32(const struct Vec2F &s) {
  x = static_cast<Si32>(s.x);
  y = static_cast<Si32>(s.y);
}

Vec2Si32::Vec2Si32(const struct Vec2D &s) {
  x = static_cast<Si32>(s.x);
  y = static_cast<Si32>(s.y);
}

Vec4Si32::Vec4Si32(const struct Vec4F &s) {
  x = static_cast<Si32>(s.x);
  y = static_cast<Si32>(s.y);
  z = static_cast<Si32>(s.z);
  w = static_cast<Si32>(s.w);
}

std::ostream& operator<<(std::ostream& os, const Vec2F& vec) {
  os << "(" << vec.x << ", " << vec.y << ")";
  return os;
}

std::ostream& operator<<(std::ostream& os, const Vec2D& vec) {
  os << "(" << vec.x << ", " << vec.y << ")";
  return os;
}

}  // namespace arctic
